/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 17:24:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.identitytoolkit.model;

/**
 * Request to get the account information.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Identity Toolkit API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class IdentitytoolkitRelyingpartyGetAccountInfoRequest extends com.google.api.client.json.GenericJson {

  /**
   * The list of emails of the users to inquiry.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> email;

  /**
   * The GITKit token of the authenticated user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String idToken;

  /**
   * The list of local ID's of the users to inquiry.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> localId;

  /**
   * The list of emails of the users to inquiry.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getEmail() {
    return email;
  }

  /**
   * The list of emails of the users to inquiry.
   * @param email email or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyGetAccountInfoRequest setEmail(java.util.List<java.lang.String> email) {
    this.email = email;
    return this;
  }

  /**
   * The GITKit token of the authenticated user.
   * @return value or {@code null} for none
   */
  public java.lang.String getIdToken() {
    return idToken;
  }

  /**
   * The GITKit token of the authenticated user.
   * @param idToken idToken or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyGetAccountInfoRequest setIdToken(java.lang.String idToken) {
    this.idToken = idToken;
    return this;
  }

  /**
   * The list of local ID's of the users to inquiry.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getLocalId() {
    return localId;
  }

  /**
   * The list of local ID's of the users to inquiry.
   * @param localId localId or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyGetAccountInfoRequest setLocalId(java.util.List<java.lang.String> localId) {
    this.localId = localId;
    return this;
  }

  @Override
  public IdentitytoolkitRelyingpartyGetAccountInfoRequest set(String fieldName, Object value) {
    return (IdentitytoolkitRelyingpartyGetAccountInfoRequest) super.set(fieldName, value);
  }

  @Override
  public IdentitytoolkitRelyingpartyGetAccountInfoRequest clone() {
    return (IdentitytoolkitRelyingpartyGetAccountInfoRequest) super.clone();
  }

}
