/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 17:24:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.identitytoolkit.model;

/**
 * Request to verify the IDP assertion.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Identity Toolkit API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class IdentitytoolkitRelyingpartyVerifyAssertionRequest extends com.google.api.client.json.GenericJson {

  /**
   * The GITKit token for the non-trusted IDP pending to be confirmed by the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String pendingIdToken;

  /**
   * The post body if the request is a HTTP POST.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String postBody;

  /**
   * The URI to which the IDP redirects the user back. It may contain federated login result params
   * added by the IDP.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String requestUri;

  /**
   * The GITKit token for the non-trusted IDP pending to be confirmed by the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getPendingIdToken() {
    return pendingIdToken;
  }

  /**
   * The GITKit token for the non-trusted IDP pending to be confirmed by the user.
   * @param pendingIdToken pendingIdToken or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyVerifyAssertionRequest setPendingIdToken(java.lang.String pendingIdToken) {
    this.pendingIdToken = pendingIdToken;
    return this;
  }

  /**
   * The post body if the request is a HTTP POST.
   * @return value or {@code null} for none
   */
  public java.lang.String getPostBody() {
    return postBody;
  }

  /**
   * The post body if the request is a HTTP POST.
   * @param postBody postBody or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyVerifyAssertionRequest setPostBody(java.lang.String postBody) {
    this.postBody = postBody;
    return this;
  }

  /**
   * The URI to which the IDP redirects the user back. It may contain federated login result params
   * added by the IDP.
   * @return value or {@code null} for none
   */
  public java.lang.String getRequestUri() {
    return requestUri;
  }

  /**
   * The URI to which the IDP redirects the user back. It may contain federated login result params
   * added by the IDP.
   * @param requestUri requestUri or {@code null} for none
   */
  public IdentitytoolkitRelyingpartyVerifyAssertionRequest setRequestUri(java.lang.String requestUri) {
    this.requestUri = requestUri;
    return this;
  }

  @Override
  public IdentitytoolkitRelyingpartyVerifyAssertionRequest set(String fieldName, Object value) {
    return (IdentitytoolkitRelyingpartyVerifyAssertionRequest) super.set(fieldName, value);
  }

  @Override
  public IdentitytoolkitRelyingpartyVerifyAssertionRequest clone() {
    return (IdentitytoolkitRelyingpartyVerifyAssertionRequest) super.clone();
  }

}
