/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-24 at 17:24:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.identitytoolkit.model;

/**
 * Request of getting a code for user confirmation (reset password, change email etc.) Request of
 * verifying the password. Response of getting account information. Response of resetting the
 * password. Response of verifying the IDP assertion. Response of creating the IDP authentication
 * URL. Response of getting a code for user confirmation (reset password, change email etc.).
 * Respone of setting the account information. Respone of deleting account. Respone of uploading
 * accounts in batch.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Identity Toolkit API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Relyingparty extends com.google.api.client.json.GenericJson {

  /**
   * The action code.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String action;

  /**
   * The URI used by the IDP to authenticate the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String authUri;

  /**
   * The recaptcha response from the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String captchaResp;

  /**
   * The recaptcha challenge presented to the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String challenge;

  /**
   * The opaque value used by the client to maintain context info between the authentication request
   * and the IDP callback.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String context;

  /**
   * The birth date of the IdP account.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String dateOfBirth;

  /**
   * The display name of the user. The name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * The email of the user. The email returned by the IdP. NOTE: The federated login user may not
   * own the email. The user's email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String email;

  /**
   * It's true if the email is recycled.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean emailRecycled;

  /**
   * The value is true if the IDP is also the email provider. It means the user owns the email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean emailVerified;

  /**
   * The error encountered while processing the account info.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Error> error;

  static {
    // hack to force ProGuard to consider Error used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Error.class);
  }

  /**
   * The unique ID identifies the IdP account.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String federatedId;

  /**
   * The first name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String firstName;

  /**
   * The full name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String fullName;

  /**
   * The GITKit token for authenticated user. The ID token. The user's Gitkit login token for email
   * change.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String idToken;

  /**
   * It's the identifier param in the createAuthUri request if the identifier is an email. It can be
   * used to check whether the user input email is different from the asserted email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String inputEmail;

  /**
   * The fixed string "identitytoolkit#relyingparty". The fixed string
   * identitytoolkit#relyingparty".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The language preference of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String language;

  /**
   * The last name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String lastName;

  /**
   * The RP local ID if it's already been mapped to the IdP account identified by the federated ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String localId;

  /**
   * The new email if the code is for email change.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String newEmail;

  /**
   * The nick name of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nickName;

  /**
   * The user approved request token for the OpenID OAuth extension.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String oauthRequestToken;

  /**
   * The scope for the OpenID OAuth extension.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String oauthScope;

  /**
   * The code to be send to the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String oobCode;

  /**
   * The original email stored in the mapping storage. It's returned when the federated ID is
   * associated to a different email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String originalEmail;

  /**
   * The URI of the public accessible profiel picture.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String photoUrl;

  /**
   * The associated IDPs of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> provider;

  /**
   * The IdP ID. For white listed IdPs it's a short domain name e.g. google.com, aol.com, live.net
   * and yahoo.com. If the "providerId" param is set to OpenID OP identifer other than the whilte
   * listed IdPs the OP identifier is returned. If the "identifier" param is federated ID in the
   * createAuthUri request. The domain part of the federated ID is returned.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String providerId;

  /**
   * Existing IDP's for the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> providers;

  /**
   * Whether the email is registered. Whether the user is registered if the identifier is an email.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean registered;

  /**
   * The request type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String requestType;

  /**
   * The timezone of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String timeZone;

  /**
   * The IP address of the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String userIp;

  /**
   * The info of the users.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Users> users;

  static {
    // hack to force ProGuard to consider Users used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Users.class);
  }

  /**
   * When action is 'map', contains the idps which can be used for confirmation.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> verifiedProvider;

  /**
   * The action code.
   * @return value or {@code null} for none
   */
  public java.lang.String getAction() {
    return action;
  }

  /**
   * The action code.
   * @param action action or {@code null} for none
   */
  public Relyingparty setAction(java.lang.String action) {
    this.action = action;
    return this;
  }

  /**
   * The URI used by the IDP to authenticate the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getAuthUri() {
    return authUri;
  }

  /**
   * The URI used by the IDP to authenticate the user.
   * @param authUri authUri or {@code null} for none
   */
  public Relyingparty setAuthUri(java.lang.String authUri) {
    this.authUri = authUri;
    return this;
  }

  /**
   * The recaptcha response from the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getCaptchaResp() {
    return captchaResp;
  }

  /**
   * The recaptcha response from the user.
   * @param captchaResp captchaResp or {@code null} for none
   */
  public Relyingparty setCaptchaResp(java.lang.String captchaResp) {
    this.captchaResp = captchaResp;
    return this;
  }

  /**
   * The recaptcha challenge presented to the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getChallenge() {
    return challenge;
  }

  /**
   * The recaptcha challenge presented to the user.
   * @param challenge challenge or {@code null} for none
   */
  public Relyingparty setChallenge(java.lang.String challenge) {
    this.challenge = challenge;
    return this;
  }

  /**
   * The opaque value used by the client to maintain context info between the authentication request
   * and the IDP callback.
   * @return value or {@code null} for none
   */
  public java.lang.String getContext() {
    return context;
  }

  /**
   * The opaque value used by the client to maintain context info between the authentication request
   * and the IDP callback.
   * @param context context or {@code null} for none
   */
  public Relyingparty setContext(java.lang.String context) {
    this.context = context;
    return this;
  }

  /**
   * The birth date of the IdP account.
   * @return value or {@code null} for none
   */
  public java.lang.String getDateOfBirth() {
    return dateOfBirth;
  }

  /**
   * The birth date of the IdP account.
   * @param dateOfBirth dateOfBirth or {@code null} for none
   */
  public Relyingparty setDateOfBirth(java.lang.String dateOfBirth) {
    this.dateOfBirth = dateOfBirth;
    return this;
  }

  /**
   * The display name of the user. The name of the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * The display name of the user. The name of the user.
   * @param displayName displayName or {@code null} for none
   */
  public Relyingparty setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * The email of the user. The email returned by the IdP. NOTE: The federated login user may not
   * own the email. The user's email.
   * @return value or {@code null} for none
   */
  public java.lang.String getEmail() {
    return email;
  }

  /**
   * The email of the user. The email returned by the IdP. NOTE: The federated login user may not
   * own the email. The user's email.
   * @param email email or {@code null} for none
   */
  public Relyingparty setEmail(java.lang.String email) {
    this.email = email;
    return this;
  }

  /**
   * It's true if the email is recycled.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getEmailRecycled() {
    return emailRecycled;
  }

  /**
   * It's true if the email is recycled.
   * @param emailRecycled emailRecycled or {@code null} for none
   */
  public Relyingparty setEmailRecycled(java.lang.Boolean emailRecycled) {
    this.emailRecycled = emailRecycled;
    return this;
  }

  /**
   * The value is true if the IDP is also the email provider. It means the user owns the email.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getEmailVerified() {
    return emailVerified;
  }

  /**
   * The value is true if the IDP is also the email provider. It means the user owns the email.
   * @param emailVerified emailVerified or {@code null} for none
   */
  public Relyingparty setEmailVerified(java.lang.Boolean emailVerified) {
    this.emailVerified = emailVerified;
    return this;
  }

  /**
   * The error encountered while processing the account info.
   * @return value or {@code null} for none
   */
  public java.util.List<Error> getError() {
    return error;
  }

  /**
   * The error encountered while processing the account info.
   * @param error error or {@code null} for none
   */
  public Relyingparty setError(java.util.List<Error> error) {
    this.error = error;
    return this;
  }

  /**
   * The unique ID identifies the IdP account.
   * @return value or {@code null} for none
   */
  public java.lang.String getFederatedId() {
    return federatedId;
  }

  /**
   * The unique ID identifies the IdP account.
   * @param federatedId federatedId or {@code null} for none
   */
  public Relyingparty setFederatedId(java.lang.String federatedId) {
    this.federatedId = federatedId;
    return this;
  }

  /**
   * The first name of the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getFirstName() {
    return firstName;
  }

  /**
   * The first name of the user.
   * @param firstName firstName or {@code null} for none
   */
  public Relyingparty setFirstName(java.lang.String firstName) {
    this.firstName = firstName;
    return this;
  }

  /**
   * The full name of the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getFullName() {
    return fullName;
  }

  /**
   * The full name of the user.
   * @param fullName fullName or {@code null} for none
   */
  public Relyingparty setFullName(java.lang.String fullName) {
    this.fullName = fullName;
    return this;
  }

  /**
   * The GITKit token for authenticated user. The ID token. The user's Gitkit login token for email
   * change.
   * @return value or {@code null} for none
   */
  public java.lang.String getIdToken() {
    return idToken;
  }

  /**
   * The GITKit token for authenticated user. The ID token. The user's Gitkit login token for email
   * change.
   * @param idToken idToken or {@code null} for none
   */
  public Relyingparty setIdToken(java.lang.String idToken) {
    this.idToken = idToken;
    return this;
  }

  /**
   * It's the identifier param in the createAuthUri request if the identifier is an email. It can be
   * used to check whether the user input email is different from the asserted email.
   * @return value or {@code null} for none
   */
  public java.lang.String getInputEmail() {
    return inputEmail;
  }

  /**
   * It's the identifier param in the createAuthUri request if the identifier is an email. It can be
   * used to check whether the user input email is different from the asserted email.
   * @param inputEmail inputEmail or {@code null} for none
   */
  public Relyingparty setInputEmail(java.lang.String inputEmail) {
    this.inputEmail = inputEmail;
    return this;
  }

  /**
   * The fixed string "identitytoolkit#relyingparty". The fixed string
   * identitytoolkit#relyingparty".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The fixed string "identitytoolkit#relyingparty". The fixed string
   * identitytoolkit#relyingparty".
   * @param kind kind or {@code null} for none
   */
  public Relyingparty setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The language preference of the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getLanguage() {
    return language;
  }

  /**
   * The language preference of the user.
   * @param language language or {@code null} for none
   */
  public Relyingparty setLanguage(java.lang.String language) {
    this.language = language;
    return this;
  }

  /**
   * The last name of the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getLastName() {
    return lastName;
  }

  /**
   * The last name of the user.
   * @param lastName lastName or {@code null} for none
   */
  public Relyingparty setLastName(java.lang.String lastName) {
    this.lastName = lastName;
    return this;
  }

  /**
   * The RP local ID if it's already been mapped to the IdP account identified by the federated ID.
   * @return value or {@code null} for none
   */
  public java.lang.String getLocalId() {
    return localId;
  }

  /**
   * The RP local ID if it's already been mapped to the IdP account identified by the federated ID.
   * @param localId localId or {@code null} for none
   */
  public Relyingparty setLocalId(java.lang.String localId) {
    this.localId = localId;
    return this;
  }

  /**
   * The new email if the code is for email change.
   * @return value or {@code null} for none
   */
  public java.lang.String getNewEmail() {
    return newEmail;
  }

  /**
   * The new email if the code is for email change.
   * @param newEmail newEmail or {@code null} for none
   */
  public Relyingparty setNewEmail(java.lang.String newEmail) {
    this.newEmail = newEmail;
    return this;
  }

  /**
   * The nick name of the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getNickName() {
    return nickName;
  }

  /**
   * The nick name of the user.
   * @param nickName nickName or {@code null} for none
   */
  public Relyingparty setNickName(java.lang.String nickName) {
    this.nickName = nickName;
    return this;
  }

  /**
   * The user approved request token for the OpenID OAuth extension.
   * @return value or {@code null} for none
   */
  public java.lang.String getOauthRequestToken() {
    return oauthRequestToken;
  }

  /**
   * The user approved request token for the OpenID OAuth extension.
   * @param oauthRequestToken oauthRequestToken or {@code null} for none
   */
  public Relyingparty setOauthRequestToken(java.lang.String oauthRequestToken) {
    this.oauthRequestToken = oauthRequestToken;
    return this;
  }

  /**
   * The scope for the OpenID OAuth extension.
   * @return value or {@code null} for none
   */
  public java.lang.String getOauthScope() {
    return oauthScope;
  }

  /**
   * The scope for the OpenID OAuth extension.
   * @param oauthScope oauthScope or {@code null} for none
   */
  public Relyingparty setOauthScope(java.lang.String oauthScope) {
    this.oauthScope = oauthScope;
    return this;
  }

  /**
   * The code to be send to the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getOobCode() {
    return oobCode;
  }

  /**
   * The code to be send to the user.
   * @param oobCode oobCode or {@code null} for none
   */
  public Relyingparty setOobCode(java.lang.String oobCode) {
    this.oobCode = oobCode;
    return this;
  }

  /**
   * The original email stored in the mapping storage. It's returned when the federated ID is
   * associated to a different email.
   * @return value or {@code null} for none
   */
  public java.lang.String getOriginalEmail() {
    return originalEmail;
  }

  /**
   * The original email stored in the mapping storage. It's returned when the federated ID is
   * associated to a different email.
   * @param originalEmail originalEmail or {@code null} for none
   */
  public Relyingparty setOriginalEmail(java.lang.String originalEmail) {
    this.originalEmail = originalEmail;
    return this;
  }

  /**
   * The URI of the public accessible profiel picture.
   * @return value or {@code null} for none
   */
  public java.lang.String getPhotoUrl() {
    return photoUrl;
  }

  /**
   * The URI of the public accessible profiel picture.
   * @param photoUrl photoUrl or {@code null} for none
   */
  public Relyingparty setPhotoUrl(java.lang.String photoUrl) {
    this.photoUrl = photoUrl;
    return this;
  }

  /**
   * The associated IDPs of the user.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getProvider() {
    return provider;
  }

  /**
   * The associated IDPs of the user.
   * @param provider provider or {@code null} for none
   */
  public Relyingparty setProvider(java.util.List<java.lang.String> provider) {
    this.provider = provider;
    return this;
  }

  /**
   * The IdP ID. For white listed IdPs it's a short domain name e.g. google.com, aol.com, live.net
   * and yahoo.com. If the "providerId" param is set to OpenID OP identifer other than the whilte
   * listed IdPs the OP identifier is returned. If the "identifier" param is federated ID in the
   * createAuthUri request. The domain part of the federated ID is returned.
   * @return value or {@code null} for none
   */
  public java.lang.String getProviderId() {
    return providerId;
  }

  /**
   * The IdP ID. For white listed IdPs it's a short domain name e.g. google.com, aol.com, live.net
   * and yahoo.com. If the "providerId" param is set to OpenID OP identifer other than the whilte
   * listed IdPs the OP identifier is returned. If the "identifier" param is federated ID in the
   * createAuthUri request. The domain part of the federated ID is returned.
   * @param providerId providerId or {@code null} for none
   */
  public Relyingparty setProviderId(java.lang.String providerId) {
    this.providerId = providerId;
    return this;
  }

  /**
   * Existing IDP's for the user.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getProviders() {
    return providers;
  }

  /**
   * Existing IDP's for the user.
   * @param providers providers or {@code null} for none
   */
  public Relyingparty setProviders(java.util.List<java.lang.String> providers) {
    this.providers = providers;
    return this;
  }

  /**
   * Whether the email is registered. Whether the user is registered if the identifier is an email.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getRegistered() {
    return registered;
  }

  /**
   * Whether the email is registered. Whether the user is registered if the identifier is an email.
   * @param registered registered or {@code null} for none
   */
  public Relyingparty setRegistered(java.lang.Boolean registered) {
    this.registered = registered;
    return this;
  }

  /**
   * The request type.
   * @return value or {@code null} for none
   */
  public java.lang.String getRequestType() {
    return requestType;
  }

  /**
   * The request type.
   * @param requestType requestType or {@code null} for none
   */
  public Relyingparty setRequestType(java.lang.String requestType) {
    this.requestType = requestType;
    return this;
  }

  /**
   * The timezone of the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getTimeZone() {
    return timeZone;
  }

  /**
   * The timezone of the user.
   * @param timeZone timeZone or {@code null} for none
   */
  public Relyingparty setTimeZone(java.lang.String timeZone) {
    this.timeZone = timeZone;
    return this;
  }

  /**
   * The IP address of the user.
   * @return value or {@code null} for none
   */
  public java.lang.String getUserIp() {
    return userIp;
  }

  /**
   * The IP address of the user.
   * @param userIp userIp or {@code null} for none
   */
  public Relyingparty setUserIp(java.lang.String userIp) {
    this.userIp = userIp;
    return this;
  }

  /**
   * The info of the users.
   * @return value or {@code null} for none
   */
  public java.util.List<Users> getUsers() {
    return users;
  }

  /**
   * The info of the users.
   * @param users users or {@code null} for none
   */
  public Relyingparty setUsers(java.util.List<Users> users) {
    this.users = users;
    return this;
  }

  /**
   * When action is 'map', contains the idps which can be used for confirmation.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getVerifiedProvider() {
    return verifiedProvider;
  }

  /**
   * When action is 'map', contains the idps which can be used for confirmation.
   * @param verifiedProvider verifiedProvider or {@code null} for none
   */
  public Relyingparty setVerifiedProvider(java.util.List<java.lang.String> verifiedProvider) {
    this.verifiedProvider = verifiedProvider;
    return this;
  }

  @Override
  public Relyingparty set(String fieldName, Object value) {
    return (Relyingparty) super.set(fieldName, value);
  }

  @Override
  public Relyingparty clone() {
    return (Relyingparty) super.clone();
  }

  /**
   * Model definition for RelyingpartyError.
   */
  public static final class Error extends com.google.api.client.json.GenericJson {

    /**
     * The index of the malformed account, starting from 0.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer index;

    /**
     * Detailed error message for the account info.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String message;

    /**
     * The index of the malformed account, starting from 0.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getIndex() {
      return index;
    }

    /**
     * The index of the malformed account, starting from 0.
     * @param index index or {@code null} for none
     */
    public Error setIndex(java.lang.Integer index) {
      this.index = index;
      return this;
    }

    /**
     * Detailed error message for the account info.
     * @return value or {@code null} for none
     */
    public java.lang.String getMessage() {
      return message;
    }

    /**
     * Detailed error message for the account info.
     * @param message message or {@code null} for none
     */
    public Error setMessage(java.lang.String message) {
      this.message = message;
      return this;
    }

    @Override
    public Error set(String fieldName, Object value) {
      return (Error) super.set(fieldName, value);
    }

    @Override
    public Error clone() {
      return (Error) super.clone();
    }

  }

  /**
   * Model definition for RelyingpartyUsers.
   */
  public static final class Users extends com.google.api.client.json.GenericJson {

    /**
     * The user's date of birth.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String dateOfBirth;

    /**
     * The name of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String displayName;

    /**
     * The email returned by the IdP. NOTE: The federated login user may not own the email.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String email;

    /**
     * The language of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String language;

    /**
     * The local ID of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String localId;

    /**
     * The user's hashed password.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String password;

    /**
     * The timestamp when the password was last updated.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long passwordUpdatedAt;

    /**
     * The URL of the user profile photo.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String photoUrl;

    /**
     * The IDP of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<java.lang.String> provider;

    /**
     * The user's password salt.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String salt;

    /**
     * The time zone of the user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String timeZone;

    /**
     * Version of the user's password.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Integer version;

    /**
     * The user's date of birth.
     * @return value or {@code null} for none
     */
    public java.lang.String getDateOfBirth() {
      return dateOfBirth;
    }

    /**
     * The user's date of birth.
     * @param dateOfBirth dateOfBirth or {@code null} for none
     */
    public Users setDateOfBirth(java.lang.String dateOfBirth) {
      this.dateOfBirth = dateOfBirth;
      return this;
    }

    /**
     * The name of the user.
     * @return value or {@code null} for none
     */
    public java.lang.String getDisplayName() {
      return displayName;
    }

    /**
     * The name of the user.
     * @param displayName displayName or {@code null} for none
     */
    public Users setDisplayName(java.lang.String displayName) {
      this.displayName = displayName;
      return this;
    }

    /**
     * The email returned by the IdP. NOTE: The federated login user may not own the email.
     * @return value or {@code null} for none
     */
    public java.lang.String getEmail() {
      return email;
    }

    /**
     * The email returned by the IdP. NOTE: The federated login user may not own the email.
     * @param email email or {@code null} for none
     */
    public Users setEmail(java.lang.String email) {
      this.email = email;
      return this;
    }

    /**
     * The language of the user.
     * @return value or {@code null} for none
     */
    public java.lang.String getLanguage() {
      return language;
    }

    /**
     * The language of the user.
     * @param language language or {@code null} for none
     */
    public Users setLanguage(java.lang.String language) {
      this.language = language;
      return this;
    }

    /**
     * The local ID of the user.
     * @return value or {@code null} for none
     */
    public java.lang.String getLocalId() {
      return localId;
    }

    /**
     * The local ID of the user.
     * @param localId localId or {@code null} for none
     */
    public Users setLocalId(java.lang.String localId) {
      this.localId = localId;
      return this;
    }

    /**
     * The user's hashed password.
     * @see #decodePassword()
     * @return value or {@code null} for none
     */
    public java.lang.String getPassword() {
      return password;
    }

    /**
     * The user's hashed password.
     * @see #getPassword()
     * @return Base64 decoded value or {@code null} for none
     *
     * @since 1.14
     */
    public byte[] decodePassword() {
      return com.google.api.client.util.Base64.decodeBase64(password);
    }

    /**
     * The user's hashed password.
     * @see #encodePassword()
     * @param password password or {@code null} for none
     */
    public Users setPassword(java.lang.String password) {
      this.password = password;
      return this;
    }

    /**
     * The user's hashed password.
     * @see #setPassword()
     *
     * <p>
     * The value is encoded Base64 or {@code null} for none.
     * </p>
     *
     * @since 1.14
     */
    public Users encodePassword(byte[] password) {
      this.password = com.google.api.client.util.Base64.encodeBase64URLSafeString(password);
      return this;
    }

    /**
     * The timestamp when the password was last updated.
     * @return value or {@code null} for none
     */
    public java.lang.Long getPasswordUpdatedAt() {
      return passwordUpdatedAt;
    }

    /**
     * The timestamp when the password was last updated.
     * @param passwordUpdatedAt passwordUpdatedAt or {@code null} for none
     */
    public Users setPasswordUpdatedAt(java.lang.Long passwordUpdatedAt) {
      this.passwordUpdatedAt = passwordUpdatedAt;
      return this;
    }

    /**
     * The URL of the user profile photo.
     * @return value or {@code null} for none
     */
    public java.lang.String getPhotoUrl() {
      return photoUrl;
    }

    /**
     * The URL of the user profile photo.
     * @param photoUrl photoUrl or {@code null} for none
     */
    public Users setPhotoUrl(java.lang.String photoUrl) {
      this.photoUrl = photoUrl;
      return this;
    }

    /**
     * The IDP of the user.
     * @return value or {@code null} for none
     */
    public java.util.List<java.lang.String> getProvider() {
      return provider;
    }

    /**
     * The IDP of the user.
     * @param provider provider or {@code null} for none
     */
    public Users setProvider(java.util.List<java.lang.String> provider) {
      this.provider = provider;
      return this;
    }

    /**
     * The user's password salt.
     * @see #decodeSalt()
     * @return value or {@code null} for none
     */
    public java.lang.String getSalt() {
      return salt;
    }

    /**
     * The user's password salt.
     * @see #getSalt()
     * @return Base64 decoded value or {@code null} for none
     *
     * @since 1.14
     */
    public byte[] decodeSalt() {
      return com.google.api.client.util.Base64.decodeBase64(salt);
    }

    /**
     * The user's password salt.
     * @see #encodeSalt()
     * @param salt salt or {@code null} for none
     */
    public Users setSalt(java.lang.String salt) {
      this.salt = salt;
      return this;
    }

    /**
     * The user's password salt.
     * @see #setSalt()
     *
     * <p>
     * The value is encoded Base64 or {@code null} for none.
     * </p>
     *
     * @since 1.14
     */
    public Users encodeSalt(byte[] salt) {
      this.salt = com.google.api.client.util.Base64.encodeBase64URLSafeString(salt);
      return this;
    }

    /**
     * The time zone of the user.
     * @return value or {@code null} for none
     */
    public java.lang.String getTimeZone() {
      return timeZone;
    }

    /**
     * The time zone of the user.
     * @param timeZone timeZone or {@code null} for none
     */
    public Users setTimeZone(java.lang.String timeZone) {
      this.timeZone = timeZone;
      return this;
    }

    /**
     * Version of the user's password.
     * @return value or {@code null} for none
     */
    public java.lang.Integer getVersion() {
      return version;
    }

    /**
     * Version of the user's password.
     * @param version version or {@code null} for none
     */
    public Users setVersion(java.lang.Integer version) {
      this.version = version;
      return this;
    }

    @Override
    public Users set(String fieldName, Object value) {
      return (Users) super.set(fieldName, value);
    }

    @Override
    public Users clone() {
      return (Users) super.clone();
    }

  }

}
